#include <cstdio>

using namespace std;


#include "adlib.hh"
static Adlib Adlib;

#define OPL3_EMULATOR
#include "m_opl.h"


void outportb(const WORD port, const BYTE value)
{
	if(port >= 0x388 && port <= 0x38B)
		Adlib.Out(port-0x388, value);
}

BYTE inportb(const WORD port)
{
	if(port >= 0x388 && port <= 0x38B)
		return Adlib.In(port-0x388);
	return 0;
}

void adlib_delay(unsigned usecs)
{
	Adlib.Run(usecs / 1E6);
}


/* The rest of main.cc is a testing environment,
 * and doesn't implement the emulator.
 */



int main(void)
{
	musicdriver *drv = &OPLDriver;
	
	if(drv->detect() < 0)
	{
		fprintf(stderr, "OPL3 was not detected! Emulator is faulty!\n");
		return -1;
	}
	fprintf(stderr, "OPL3 successfully detected!\n");
	
	drv->reset();
	
	drv->close();
	
	fprintf(stderr, "Cheers. Bugless so far. This is version "VERSION".\n");
	
	return 0;
}
