#ifndef opl3emu_operator_hh
#define opl3emu_operator_hh

class Operator
{
	bool tremolo;
	bool vibrato;
	bool dosustain;
	bool KSR;                  // Decrease note lengths when freq grows?
	unsigned char freqmul;
	unsigned char KSL;         // 0..3 - Attenuation = {0,1.5,3,6}[octave]
	unsigned char outputlevel; // 0..63- Attenuation = 0=loudest, 63=softest
	unsigned char attack;      // 0..15- Rising time.
	unsigned char decay;       // 0..15- 
	unsigned char sustain;     // 0..15-
	unsigned char release;     // 0..15- Rate at disappear after key-off.
	
	Operator *chain;
	enum { mod_freq, mod_add } chaintype;
	
public:
	Operator() : chain(0)
	{
	}
	
	const unsigned multiplyfreq(unsigned freq) const;
	
	void Write20(unsigned char value);
	void Write40(unsigned char value);
	void Write60(unsigned char value);
	void Write80(unsigned char value);
	
	void Modulate(Operator &o);
	void AddTo(Operator &o);
	void Unlink(void);
};

/* Return value: root operator */
extern Operator &OPL2_link(
    Operator &op1, Operator &op2,
    unsigned mode);

/* Return value: root operator */
extern Operator &OPL3_link(
    Operator &op1, Operator &op2,
    Operator &op3, Operator &op4,
    unsigned mode);

extern unsigned OperatorPortOffset(unsigned channel);
extern unsigned PortOffsetOperator(unsigned offset);

#endif
